//##############################################################################
//
// FILE:   usb_hal.h
//
// TITLE:  Compatability layer for ported software.
//
//##############################################################################
// $TI Release: $
// $Release Date: $
// $Copyright: $
//##############################################################################

#ifndef USB_HAL_H
#define USB_HAL_H

//******************************************************************************
// If building with a C++ compiler, make all of the definitions in this header
// have a C binding.
//******************************************************************************
#ifdef __cplusplus
extern "C"
{
#endif

//
// Included Files
//
#include "driverlib.h"
#include "device.h"
#include "usblib.h"
#include "usblibpriv.h"
#include "device/usbdevice.h"
#include "host/usbhost.h"
#include "host/usbhostpriv.h"
#include "usblibpriv.h"

//
// Defines.
//

//
// Define to pass to SysCtl_setAuxClock(). Will configure the clock as follows:
// AUXPLLCLK =
//       20MHz (XTAL_OSC) * 24 (IMULT) / (2 (REFDIV) * 4 (ODIV) * 1(AUXPLLDIV) )
//
#define DEVICE_AUXSETCLOCK_CFG_USB   (SYSCTL_AUXPLL_OSCSRC_XTAL | \
                                      SYSCTL_AUXPLL_IMULT(24) |  \
                                      SYSCTL_REFDIV(2U) | SYSCTL_ODIV(4U) | \
                                      SYSCTL_AUXPLL_DIV_1 | \
                                      SYSCTL_AUXPLL_ENABLE | \
                                      SYSCTL_DCC_BASE_0)

//******************************************************************************
//! \addtogroup c2000_specific
//! @{
//******************************************************************************
extern void USBGPIOEnable(void);
extern void CPUTimerInit(void);
extern void USBDelay(uint32_t ui32Delay);
extern void f28x_USB0DeviceIntHandler(void);
extern void f28x_USB0HostIntHandler(void);
extern void f28x_USB0DualModeIntHandler(void);
extern void f28x_USB0OTGModeIntHandler(void);

//******************************************************************************
// Mark the end of the C bindings section for C++ compilers.
//******************************************************************************
#ifdef __cplusplus
}
#endif

//******************************************************************************
// Close the Doxygen group.
//! @}
//******************************************************************************

#endif //  USB_HAL_H
